/***********
  GPS_Time & CLIENT WiFi local (ip=192.168.4.1/)
  pour ESP32 (TTGO T-Display, avec petit ecran LCD couleur IPS ST7789V  1.14 Inch 135x240 px)


il faut choisir (décommenter) la ligne suivante, dans le fichier /libraries/TFT_eSPI/User_Setup_Select.h :
  #include <User_Setups/Setup25_TTGO_T_Display.h>    // Setup file for ESP32 and TTGO T-Display ST7789V SPI bus TFT

  voir l'exemple "Colour_Test"
  
************/
#define Version "2.0"

#include <SoftwareSerial.h>
#include <TFT_eSPI.h>  
#include <TimeLib.h>          // include Arduino time library

#include <WiFi.h>
#include <HTTPClient.h>


const char* ssid = "TPGPS_34"; 
const char* password = "94r6tkJ31";

//IP address with URL path
//const char* srvName_heure = "http://192.168.4.1/heure";
//const char* srvName_date  = "http://192.168.4.1/date";
const char* srvName_HR  = "http://192.168.4.1/HR";

TFT_eSPI ECRAN_1 = TFT_eSPI();

//String recp_time = "{}";
//String recp_date = "{}";
String recp_HR = "{}";

uint8_t WiFi_status=0;

uint32_t memoMillis = 0;
uint32_t currentMillis;
const uint32_t tempo = 2000; 


uint16_t annee;
uint8_t mois;
uint8_t jour;

uint8_t annee_in=0;
uint8_t mois_in=0;
uint8_t jour_in=0;

uint8_t heures=0;
uint8_t minutes=0;
uint8_t secondes=0;
uint8_t jour_de_la_semaine;

uint8_t heures_in=0;
uint8_t minutes_in=0;
uint8_t secondes_in=0;

uint16_t compte1=0;
uint16_t compte2=0;

String annee_txt;
String mois_txt;
String jour_txt;
String date_txt;

String heures_txt;
String minutes_txt;
String secondes_txt;



void setup()
{
	Serial.begin(115200);
	delay(2000);
	Serial.println("ESP CLIENT WiFi");
	Serial.println("Setup");
	
	ECRAN_1.init();
	ECRAN_1.setRotation(1);
	ECRAN_1.fillScreen(TFT_BLACK);
	ECRAN_1.setCursor(0, 0, 2); // Set "cursor" at top left corner of display (0,0) and select font 4
	ECRAN_1.setTextColor(TFT_WHITE, TFT_BLACK);
	ECRAN_1.println("Horloge Client WiFi");
	
	delay(500);
	
	ECRAN_1.setCursor(0, 20, 4);
	ECRAN_1.setTextColor(TFT_YELLOW, TFT_BLACK);	
	ECRAN_1.print("Connexion :");

	WiFi.persistent(false);
	WiFi.begin(ssid, password);
	delay(2000);

	

	Serial.println("Connecting");

	ECRAN_1.setTextColor(TFT_BLUE, TFT_BLACK);
	//ECRAN_1.setTextFont(1);
	ECRAN_1.setCursor(0, 40, 1);
	while(WiFi.status() != WL_CONNECTED)
	{ 
		delay(500);
		ECRAN_1.print(".");
		Serial.print(".");
	}

	Serial.println("");
	Serial.print("Connected to WiFi - IP Address : ");
	Serial.println(WiFi.localIP());
	Serial.println("\n");

	ECRAN_1.setTextColor(TFT_GREEN, TFT_BLACK);
	ECRAN_1.println(" ");
	ECRAN_1.println("OK");
    smartdelay(500);
    ECRAN_1.fillScreen(TFT_BLACK);

 	ECRAN_1.setCursor(130, 0, 2); // Set "cursor" at top left corner of display (0,0) and select font 4
	ECRAN_1.setTextColor(TFT_BLUE, TFT_BLACK);
	ECRAN_1.println("Client WiFi");   

	delay(500);

	compte1=8;
	affiche_date();
}



void httpGetHeureDate()
{
	Serial.println("envoi req HR");

	HTTPClient http2;

	http2.begin(srvName_HR);

	int httpResponseCode = http2.GET();

	if (httpResponseCode>0)
	{
		recp_HR = http2.getString();
	}
	http2.end();

	Serial.println("reponse: ");
	Serial.println(recp_HR);
	
}


static void smartdelay(unsigned long ms)
{
	unsigned long start = millis();
	while (millis() - start < ms) {;}
}



void ajuste_HR()
{

	Serial.print("length="); Serial.println(recp_HR.length());
	if(recp_HR.length() == 18)
	{
		
		WiFi_status =1;
		Serial.println("ajuste_HR");
		Serial.println( recp_HR);
		
		// String data_in = "11:40:30"

		
		heures_in =(recp_HR.substring(0,2)).toInt();
		Serial.println(heures_in);
		
		minutes_in =(recp_HR.substring(3,5)).toInt();
		Serial.println(minutes_in);
		
		secondes_in =(recp_HR.substring(6,8)).toInt();
		Serial.println(secondes_in);
		//secondes_in++; // pour compenser le temps de traitement
		
		if (heures != heures_in) {heures = heures_in;}
		if (minutes != minutes_in) {minutes = minutes_in;}
		if (secondes != secondes_in) {secondes = secondes_in;}


		jour_in =(recp_HR.substring(9,11)).toInt();
		Serial.println(jour_in);
		
		mois_in =(recp_HR.substring(12,14)).toInt();
		Serial.println(mois_in);
		
		annee_in =(recp_HR.substring(15,17)).toInt();
		Serial.println(annee_in);

		
		if (jour != jour_in) {jour = jour_in;}
		if (mois != mois_in) {mois = mois_in;}
		if (annee != annee_in) {annee = annee_in;}
		
	}
	else {WiFi_status=0;}
	
}


void calcul_jour_de_la_semaine()
{
// d'après l'Algorithme de Mike Keith
  uint16_t d, m, y, z, jds;
  
  d=jour;
  m=mois;
  y=annee;

  if (m>=3)
  {
    jds = ( ((23*m)/9) + d + 4 + y + (y/4) - (y/100) + (y/400) - 2 ) % 7;
  }
  else
  {
    z = y-1;
    jds = ( ((23*m)/9) + d + 4 + y + (z/4) - (z/100) + (z/400) ) % 7;
  }
  jour_de_la_semaine = jds;
}


String conv_time(uint8_t t)
{
	String r;
	r=String(t);
	if (t<10) {r="0"+r;}
	return r;
}



void affiche_date()
{
	Serial.println("affiche_date");
	date_txt="";

	calcul_jour_de_la_semaine();
	
	switch (jour_de_la_semaine) 
	{
		case 0:	{ date_txt+="Dim ";} break;
		case 1:	{ date_txt+="Lun ";} break;
		case 2:	{ date_txt+="Mar ";} break;
		case 3:	{ date_txt+="Mer ";} break;
		case 4:	{ date_txt+="Jeu ";} break;;
		case 5:	{ date_txt+="Ven ";} break;
		case 6:	{ date_txt+="Sam ";} break;
	}
	date_txt+=" ";
	date_txt += String(conv_time(jour));
	date_txt+=" ";

	switch (mois) 
	{
		case  1: {date_txt+="Janv "; } break;
		case  2: {date_txt+="Fev  "; } break;
		case  3: {date_txt+="Mars "; } break;
		case  4: {date_txt+="Avr  "; } break;
		case  5: {date_txt+="Mai  "; } break;
		case  6: {date_txt+="Juin "; } break;
		case  7: {date_txt+="Juil "; } break;
		case  8: {date_txt+="Aout "; } break;
		case  9: {date_txt+="Sept "; } break;
		case 10: {date_txt+="Oct  "; } break;
		case 11: {date_txt+="Nov  "; } break;
		case 12: {date_txt+="Dec  "; } break;
	}

	date_txt+=" ";
	Serial.print("date_txt="); Serial.println(date_txt);
	//if (annee_in >0) // pour éviter d'afficher une date fantaisiste au départ
	{
		uint16_t annee_in2 = annee_in + 2000;
		annee_txt = (String)annee_in2;
		Serial.print("annee_txt="); Serial.println(annee_txt);
		
		
		date_txt += annee_txt;

		ECRAN_1.setCursor(0, 100, 4);
		ECRAN_1.setTextColor(TFT_CYAN, TFT_BLACK);	
		ECRAN_1.print(date_txt);
	}
   
}



void affiche_heure()
{
	Serial.println("affiche_heure");
    ECRAN_1.setCursor(20, 30, 6);
	ECRAN_1.setTextColor(TFT_YELLOW, TFT_BLACK);
	
	if(heures<10){ECRAN_1.print(0);}	
	ECRAN_1.print(heures);
	ECRAN_1.print(":");
	if(minutes<10){ECRAN_1.print(0);}
	ECRAN_1.print(minutes);

	ECRAN_1.print("   ");
	ECRAN_1.setTextColor(TFT_DARKGREY, TFT_BLACK);
	if(secondes<10){ECRAN_1.print(0);}
	ECRAN_1.print(secondes);

	if(WiFi_status == 1) {ECRAN_1.fillCircle(233, 5, 5,TFT_GREEN );} else {ECRAN_1.fillCircle(233, 5, 5,TFT_RED );}
}



void incremente_heure(uint8_t nb_s)
{
	for (uint8_t n=0; n<nb_s; n++)
	{
		if (secondes < 59) {secondes+=1;}
		else
		{
			secondes=0;
			if (minutes < 59) {minutes+=1;}
			else
			{
				minutes=0;
				if (heures < 23) {heures+=1;}
				else
				heures=0;
			}
		}
	}
}



void loop()
{
	compte1++;
	Serial.println(compte1);

	if ((compte1 % 10)==0) // toutes les 10s
	{
		compte2++;

		recp_HR = "{}";
		if(WiFi.status()== WL_CONNECTED )
		{
			httpGetHeureDate();
			ajuste_HR();
			Serial.println("------");
		}
		else { Serial.println("WiFi Disconnected"); }

	}
	
	incremente_heure(1);  // 1s
	smartdelay(1000);
	
	affiche_heure();
	
	affiche_date();
	

}
