/***********
  GPS_Time & SERVEUR WiFi local (ip=192.168.4.1/)
  pour ESP32 (TTGO T-Display, avec petit ecran LCD couleur IPS ST7789V  1.14 Inch 135x240 px)
  + module NEO-6M


il faut :
- choisir (décommenter) la ligne suivante, dans le fichier ~/Arduino/libraries/TFT_eSPI/User_Setup_Select.h :
ligne 62... (environ):
  #include <User_Setups/Setup25_TTGO_T_Display.h>    // Setup file for ESP32 and TTGO T-Display ST7789V SPI bus TFT


-et bien évidemment commenter tout autre ligne de choix, en particulier celle par défaut:
(ligne 22) :
#include <User_Setup.h> // Default setup is root library folder

 

  voir aussi l'exemple "Colour_Test"
  
************/

#define Version "2.1"

#include <SPI.h>  
#include <TFT_eSPI.h> 

#include <SoftwareSerial.h>
#include <TinyGPS.h>
 
#include <TimeLib.h>          // include Arduino time library
#include <WiFi.h>

// #include <WebServer.h>
#include "ESPAsyncWebServer.h"


const char* ssid = "TPGPS_34"; 
const char* password = "94r6tkJ31";


// WebServer server(80);
AsyncWebServer server(80); // Create AsyncWebServer object on port 80


static const int RxPin = 38; // UART pin_in  relié à GPS_Tx 
static const int TxPin = 37; // UART pin_out relié à GPS_Rx 

TinyGPS GPS;
TFT_eSPI ECRAN_1 = TFT_eSPI(); 
SoftwareSerial ss(RxPin, TxPin);


unsigned long age_GPS;
unsigned long date_GPS;
unsigned long heure_GPS;


uint16_t annee;
uint8_t mois;
uint8_t jour;
uint8_t jour_local; // tenant compte du décallage horaire
uint8_t heures=0;
uint8_t minutes=0;
uint8_t secondes=0;
uint8_t jour_de_la_semaine;

uint16_t compte1=0;


String annee_txt;
String mois_txt;
String jour_txt;
String date_txt;
String date_txt_compacte;

String heures_txt;
String minutes_txt;
String secondes_txt;


char heure_array[9]; // 23:56:02  + zero terminal
char date_array[17]; // Sam 30 Janv 2021 + zero terminal

char heure_date_array[28]; // 23:56:02 (Sam 30 Janv 2021) + zero terminal


void setup()
{
	Serial.begin(115200);
	ss.begin(9600);

	Serial.println("\n");
	

	ECRAN_1.init();
	ECRAN_1.setRotation(1);
	ECRAN_1.fillScreen(TFT_BLACK);
	ECRAN_1.setCursor(0, 0, 2); // Set "cursor" at top left corner of display (0,0) and select font 4
	ECRAN_1.setTextColor(TFT_WHITE, TFT_BLACK);
	ECRAN_1.println("Horloge GPS + serveur WiFi");
	delay(500);
	ECRAN_1.setCursor(0, 20, 4);
	ECRAN_1.setTextColor(TFT_YELLOW, TFT_BLACK);	
	ECRAN_1.println("Connexion...");

	WiFi.persistent(false);

	WiFi.softAP(ssid, password);  // ok, ça marche, crée un réseau. mode privé

	IPAddress IP = WiFi.softAPIP();
	Serial.print("AP IP address: "); Serial.println(IP);

	Serial.println(WiFi.status());
//  while (WiFi.status() != WL_CONNECTED)   //  <------  ne marche pas ! toujours = 255
//	while (WiFi.localIP().toString() == "0.0.0.0")    //  <------  ne marche pas non plus !!
    {
        Serial.print("...");
        delay(200);
    }

/*
	
	//= heures_txt +":" + minutes_txt +":" + secondes_txt;
	server.on("/heure", HTTP_GET, [](AsyncWebServerRequest *request)
	{
		request->send_P(200, "text/plain", heure_array);
	});


	server.on("/date", HTTP_GET, [](AsyncWebServerRequest *request)
	{
		request->send_P(200, "text/plain", date_array);
	});

*/
	server.on("/HR", HTTP_GET, [](AsyncWebServerRequest *request)
	{
		request->send_P(200, "text/plain", heure_date_array);
	});


    server.begin();

    Serial.println("Serveur web actif!");
    
    ECRAN_1.setTextColor(TFT_GREEN, TFT_BLACK);	
    ECRAN_1.println("Serveur web actif !");

    smartdelay(2000);
    ECRAN_1.fillScreen(TFT_BLACK);

 	ECRAN_1.setCursor(200, 0, 2); // Set "cursor" at top left corner of display (0,0) and select font 4
	ECRAN_1.setTextColor(TFT_BLUE, TFT_BLACK);
	ECRAN_1.println("GPS");   

	delay(1000);
	GPS.get_datetime(&date_GPS, &heure_GPS, &age_GPS);
	decode_time(date_GPS, heure_GPS);


	affiche_date();
}



static void smartdelay(unsigned long ms)
{
	unsigned long start = millis();
	do 
	{
		while (ss.available()) { GPS.encode(ss.read()); }
	}
	while (millis() - start < ms);
}



void incremente_time(uint8_t nb_s)
{
	for (uint8_t n=0; n<nb_s; n++)
	{
		if (secondes < 59) {secondes+=1;}
		else
		{
			secondes=0;
			if (minutes < 59) {minutes+=1;}
			else
			{
				minutes=0;
				if (heures < 23) {heures+=1;}
				else
				{
					heures=0;
				}
			}
		}
	}
}


void inc_heures(uint8_t nb)
{
	heures += nb;
	if (heures >= 24) {heures -= 24;}
}


void decode_time(int32_t date_GPS, int32_t time_GPS)
{
// ********************  IL FAUT MODIFIER LA LIGNE SUIVANTE DEUX FOIS PAR AN ************************
// la date des changements entre heure d'éte et heure d'hiver est un truc que seuls les shadocks peuvent prévoir
// avec la formule J = 2 Ga + (2/3 Bu - 4 Zo) * Meu
  
	uint8_t decal_Horaire_FR = 2; //décalage Horaire:  l'hiver =1 ; l'été =2 (heure allemande !)

// **************************************************************************************************	
	annee = date_GPS % 100;
	mois = (date_GPS / 100) % 100;
	jour = date_GPS / 10000;
	heures =  time_GPS / 1000000;

/*
// POUR TEST:

	annee=22;
	mois=1;
	jour=29;
	heures=17;
*/
	inc_heures(decal_Horaire_FR); 
	// problème: la date reçue change à 0h GMT ! et pas à 0h de cette cette heure décallée...
	// d'où la correction plus bas tenant compte du décallage horaire
	
	minutes = (time_GPS / 10000) % 100;
	secondes = (time_GPS / 100) % 100;

	annee_txt="";
	if (annee<10) {annee_txt="0";}
	annee_txt += (String) annee;

	mois_txt="";
	if (mois<10) {mois_txt="0";}
	mois_txt += (String) mois;
	
	jour_txt="";
	if (jour<10) {jour_txt="0";}

	if (heures >= decal_Horaire_FR)
	{
		jour_local = jour;
	}
	else
	{
// on passe iici :
// l'hiver entre minuit et 0h59 du matin heure locale FR)
// l'été entre minuit et 1h59 du matin heure locale FR)
// penser à mettre à jour deux fois par an la variable "decal_Horaire_FR" plus haut
		jour_local = jour++;
	} 
	
	jour_txt += (String) jour_local;

	heures_txt="";
	if (heures<10) {heures_txt="0";}	
	heures_txt += (String) heures;

	minutes_txt="";
	if (minutes<10) {minutes_txt="0";}	
	minutes_txt += (String) minutes;

	secondes_txt="";
	if (secondes<10) {secondes_txt="0";}	
	secondes_txt += (String) secondes;
}


void calcul_jour_de_la_semaine()
{
// d'après l'Algorithme de Mike Keith
  uint16_t d, m, y, z, jds;
  
  d=jour;
  m=mois;
  y=annee;

  if (m>=3)
  {
    jds = ( ((23*m)/9) + d + 4 + y + (y/4) - (y/100) + (y/400) - 2 ) % 7;
  }
  else
  {
    z = y-1;
    jds = ( ((23*m)/9) + d + 4 + y + (z/4) - (z/100) + (z/400) ) % 7;
  }
  jour_de_la_semaine = jds;
}


String conv_time(uint8_t t)
{
	String r;
	r=String(t);
	if (t<10) {r="0"+r;}
	return r;
}



void affiche_date()
{
	uint16_t box2_x = 0;
	uint16_t box2_y = 121-20;
	uint16_t box2_w = 175;
	uint16_t box2_h = 20;

	date_txt="";

	calcul_jour_de_la_semaine();
	
	
	switch (jour_de_la_semaine) 
	{
		case 0:	{ date_txt+="Dim ";} break;
		case 1:	{ date_txt+="Lun ";} break;
		case 2:	{ date_txt+="Mar ";} break;
		case 3:	{ date_txt+="Mer ";} break;
		case 4:	{ date_txt+="Jeu ";} break;;
		case 5:	{ date_txt+="Ven ";} break;
		case 6:	{ date_txt+="Sam ";} break;
	}	
	
	date_txt += String(conv_time(jour_local))+" ";

	switch (mois) 
	{
		case  1: {date_txt+="Janv "; } break;
		case  2: {date_txt+="Fev  "; } break;
		case  3: {date_txt+="Mars "; } break;
		case  4: {date_txt+="Avr  "; } break;
		case  5: {date_txt+="Mai  "; } break;
		case  6: {date_txt+="Juin "; } break;
		case  7: {date_txt+="Juil "; } break;
		case  8: {date_txt+="Aout "; } break;
		case  9: {date_txt+="Sept "; } break;
		case 10: {date_txt+="Oct  "; } break;
		case 11: {date_txt+="Nov  "; } break;
		case 12: {date_txt+="Dec  "; } break;
	}
	
	date_txt += "20"; // ce sera le bug de l'an 3000 ;)
	date_txt += annee_txt;

    ECRAN_1.setCursor(0, 100, 4);
	ECRAN_1.setTextColor(TFT_CYAN, TFT_BLACK);	
	ECRAN_1.print(date_txt);
   
}



void affiche_heure()
{
    ECRAN_1.setCursor(20, 30, 6);
	ECRAN_1.setTextColor(TFT_YELLOW, TFT_BLACK);

	if(heures<10){ECRAN_1.print(0);}	
	ECRAN_1.print(heures);
	ECRAN_1.print(":");
	if(minutes<10){ECRAN_1.print(0);}
	ECRAN_1.print(minutes);

	ECRAN_1.print("   ");
	ECRAN_1.setTextColor(TFT_DARKGREY, TFT_BLACK);
	if(secondes<10){ECRAN_1.print(0);}
	ECRAN_1.print(secondes);
}


void loop()
{

	Serial.println(compte1);
	// date as ddmmyy, time as hhmmsscc, and age in milliseconds
	// void get_datetime(unsigned long *date, unsigned long *time, unsigned long *age = 0);

	GPS.get_datetime(&date_GPS, &heure_GPS, &age_GPS);
	decode_time(date_GPS, heure_GPS);

	Serial.print("date_GPS: "); Serial.println(date_GPS);
	Serial.print("heure_GPS: "); Serial.println(heure_GPS);

	Serial.print("annee= ");	Serial.println(annee);
	Serial.print("mois= ");	Serial.println(mois);
	Serial.print("jour= ");	Serial.println(jour);
	
	Serial.print("heures= ");	Serial.println(heures);
	Serial.print("minutes= ");	Serial.println(minutes);
	Serial.print("secondes= ");	Serial.println(secondes);

	Serial.print("heures_txt= ");	Serial.println(heures_txt);
	Serial.print("minutes_txt= ");	Serial.println(minutes_txt);
	Serial.print("secondes_txt= ");	Serial.println(secondes_txt);


	uint8_t i=0;
	
	for(int n=0; n<2; n++)	{ heure_date_array[i]=heures_txt[n]; i++; }
	heure_date_array[i]=':'; i++;

	for(int n=0; n<2; n++)	{ heure_date_array[i]=minutes_txt[n]; i++; }
	heure_date_array[i]=':'; i++;

	for(int n=0; n<2; n++)	{ heure_date_array[i]=secondes_txt[n]; i++; }
	heure_date_array[i]='('; i++;

	for(int n=0; n<2; n++)	{ heure_date_array[i]=jour_txt[n]; i++; }
	heure_date_array[i]=':'; i++;

	for(int n=0; n<2; n++)	{ heure_date_array[i]=mois_txt[n]; i++; }
	heure_date_array[i]=':'; i++;

	for(int n=0; n<2; n++)	{ heure_date_array[i]=annee_txt[n]; i++; }
	heure_date_array[i]=')'; i++;

	
	heure_date_array[i]=0;  // zéro terminal  -> chaine C

/*
	
	heure_array[0]=heures_txt[0];
	heure_array[1]=heures_txt[1];
	heure_array[2]=':';
	heure_array[3]=minutes_txt[0];
	heure_array[4]=minutes_txt[1];
	heure_array[5]=':';
	heure_array[6]=secondes_txt[0];
	heure_array[7]=secondes_txt[1];
	heure_array[8]=0;  // zéro terminal  -> string
*/
	


// 31:01:21 pour "31 Janv 2021"

	date_array[0]=jour_txt[0];
	date_array[1]=jour_txt[1];
	date_array[2]=':';
	date_array[3]=mois_txt[0];
	date_array[4]=mois_txt[1];
	date_array[5]=':';
	date_array[6]=annee_txt[0];
	date_array[7]=annee_txt[1];
	date_array[8]=0;  // zéro terminal  -> string

	

	Serial.println();

	Serial.print("GPS.satellites: "); Serial.println(GPS.satellites());
	Serial.println(" ");

	Serial.println();

	affiche_heure();
	affiche_date();

	smartdelay(1000);
	compte1++;

}
